'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var common = require('@lezer/common');
var language = require('@codemirror/language');
var highlight = require('@codemirror/highlight');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 13,
  states: "!|QVQPOOOwQPO'#ClO!oQPO'#CkOOQO'#Co'#CoQVQPOOOVQPO,58|OVQPO,58|OVQPO,58|OOQO,59V,59VO!vQPO,59VOOQO-E6j-E6jOOQO1G.h1G.hO#rQPO1G.hO#yQPO1G.hOOQO1G.q1G.q",
  stateData: "$Q~OPOS~ORROSROTROVROWROXROYROZRO[RO^QO~OVTOWUOXVOR`XS`XT`XY`XZ`X[`X^`Xa`X]`X~O]WO~PVO]^O~PVOVTORUiSUiTUiXUiYUiZUi[Ui^UiaUi]Ui~OWUi~P!}OWUO~P!}O",
  goto: "!XdPPPPPPePPPPPPPPenPPx_ROQSTUVXQSOQXQTYSXWPOQSXQZTQ[UR]V",
  nodeNames: "⚠ LineComment Query Identifier String Boolean BooleanExpression AND OR NOT Space Tab CarriageReturn ) ( Application",
  maxTerm: 19,
  nodeProps: [
    [common.NodeProp.openedBy, 13,"("],
    [common.NodeProp.closedBy, 14,")"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 1,
  tokenData: "(z~RbXY!ZYZ!c]^!cpq!nrs!vst#exy#syz#x}!O#}!Q![#}!]!^$c!c!d$n!d!p#}!p!q&[!q!r'x!r!}#}#R#S#}#T#o#}~!`PZ~XY!Z~!hQ[~YZ!c]^!c~!sPY~pq!n~!yTOr!vrs#Ys#O!v#O#P#_#P~!v~#_OS~~#bPO~!v~#hQ#Y#Z#n#h#i#n~#sOT~~#xO^~~#}O]~~$STR~}!O#}!Q![#}!c!}#}#R#S#}#T#o#}~$hQP~OY$cZ~$c~$sVR~}!O#}!Q![#}!c!p#}!p!q%Y!q!}#}#R#S#}#T#o#}~%_VR~}!O#}!Q![#}!c!f#}!f!g%t!g!}#}#R#S#}#T#o#}~%{TV~R~}!O#}!Q![#}!c!}#}#R#S#}#T#o#}~&aVR~}!O#}!Q![#}!c!q#}!q!r&v!r!}#}#R#S#}#T#o#}~&{VR~}!O#}!Q![#}!c!v#}!v!w'b!w!}#}#R#S#}#T#o#}~'iTX~R~}!O#}!Q![#}!c!}#}#R#S#}#T#o#}~'}VR~}!O#}!Q![#}!c!t#}!t!u(d!u!}#}#R#S#}#T#o#}~(kTW~R~}!O#}!Q![#}!c!}#}#R#S#}#T#o#}",
  tokenizers: [0],
  topRules: {"Query":[0,2]},
  tokenPrec: 0
});

const simpleBooleanLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ")", align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                "AND": highlight.tags.operatorKeyword,
                "OR": highlight.tags.operatorKeyword,
                "NOT": highlight.tags.operatorKeyword,
                Identifier: highlight.tags.variableName,
                Boolean: highlight.tags.bool,
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                "( )": highlight.tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ";" }
    }
});
/**
 * Customizable autocomplete function for lang-simpleboolean
 * @param completeFromListParameter Completion[]
 * @returns CodeMirror autocomplete
 */
const simpleBooleanCompletion = (completeFromListParameter = []) => autocomplete.autocompletion({
    override: [autocomplete.completeFromList(completeFromListParameter.concat([
            { label: "AND", type: "keyword" },
            { label: "OR", type: "keyword" },
            { label: "NOT", type: "keyword" }
        ]))]
});
function simpleBoolean() {
    return new language.LanguageSupport(simpleBooleanLanguage);
}

exports.simpleBoolean = simpleBoolean;
exports.simpleBooleanCompletion = simpleBooleanCompletion;
exports.simpleBooleanLanguage = simpleBooleanLanguage;
